import React from 'react';
import logo from '@assets/images/logo.png';
import { Grid } from 'antd-mobile';
import { initDate } from '@utils/index.js';
/**
 * @刘丹: 手术室叫号
 */
class OperateScreen extends React.Component {
  constructor() {
    super();
    this.state = {
      dateStr: {},
      patList: [],
      current: 1,
      pageSize: 6, // 一页显示的数据条数
      timer: null, // 切换页面显示的定时器
    };
  }
  componentDidMount() {
    this.initDate();
    document.querySelector('html').style.fontSize = '20px';
    this.initScroll();
  }
  componentDidUpdate(prev) {
    if (prev.patList != this.props.patList) {
      this.setPatList();
    }
  }
  initDate = () => {
    this.setState({
      dateStr: initDate(),
    });
    setTimeout(() => {
      this.initDate();
    }, 3000);
  };
    // 滚动设置就诊数据
  setPatList = () => {
    if (this.state.timer) {
      clearTimeout(this.state.timer);
    }
    this.setState({
      current: 0,
      totalPage: Math.ceil(this.props.patList?.length / this.state.pageSize),
    }, () => {
      if (this.props.patList?.length <= this.state.pageSize) {
        this.setState({
          patList: this.props.patList,
        });
      } else {
        const fn = () => {
          let current = this.state.current + 1;
          if (current > this.state.totalPage) {
            current = 1;
          }
          const { pageSize } = this.state;
          this.setState({
            current,
            patList: this.props.patList.slice((current - 1) * pageSize, current * pageSize),
          });
          // 10s切换
          const timer = setTimeout(fn, 10000);
          this.setState({
            timer,
          });
        };
        fn();
      }
    });
  };
  // 初始化滚动
  initScroll = () => {
    const parentDom = document.getElementById('patWrap');
    const style = window.getComputedStyle(parentDom);
    const parentH = parentDom.offsetHeight - parseInt(style.paddingTop) - parseInt(style.paddingBottom);
    const childH = parentDom.children[0].offsetHeight;
    const pageSize = Math.floor(parentH / childH) - 1;
    this.setState({
      pageSize,
    });
  };
  render() {
    const { dateStr } = this.state;
    return (
      <div className='page-body big'>
        <div className='header'>
          <img
            src={this.props.hosLogo || logo}
            alt='Logo'
            className='logo'
            onError={(e) => {
              e.target.src = `${logo}`;
            }}
          />
          <span className='room-name'>手术状态信息</span>
          <span className='heaer-btn'>
            <span className='date'>{ dateStr.dateNow}</span>
            <br /> {dateStr.weekNow} {  dateStr.timeNow}
          </span>
        </div>
         <div className='table section' id="patWrap">
            <Grid columns={7} gap={8}>
              <Grid.Item span={1}>
                <div className='table-header'>姓名</div>
              </Grid.Item>
              <Grid.Item span={1}>
                <div className='table-header'>性别</div>
              </Grid.Item>
               <Grid.Item span={1}>
                <div className='table-header'>年龄</div>
              </Grid.Item>
              <Grid.Item span={2}>
                <div className='table-header'>手术类别</div>
              </Grid.Item>
              <Grid.Item span={1}>
                <div className='table-header'>手术状态</div>
              </Grid.Item>
              <Grid.Item span={1}>
                <div className='table-header'>手术间</div>
              </Grid.Item>
            </Grid>
            {this.state.patList.map((item,index) => {
              return (<Grid  columns={7} gap={8} key={index}>
                <Grid.Item span={1}>
                  <div className='table-content'>{ item.patName || '***'}</div>
                </Grid.Item>
                <Grid.Item span={1}>
                  <div className='table-content'>{item.patSex || '***'}</div>
                </Grid.Item>
                 <Grid.Item span={1}>
                  <div className='table-content'>{item.patAge || '***'}</div>
                </Grid.Item>
                 <Grid.Item span={2}>
                  <div className='table-content patOpeName'>
                    {item.patOpeName || '***'}
                  </div>
                </Grid.Item>
                  <Grid.Item span={1}>
                  <div className='table-content'>{ item.patOpeState || '***'}</div>
                </Grid.Item>
                  <Grid.Item span={1}>
                  <div className='table-content'>{ item.patOpeRom || '***'}</div>
                </Grid.Item>
              </Grid>);
          })}
        </div>
        <div className='footer'>过号患者:{ this.props.delayPat}</div>
      </div>
    );
  }
}

export default OperateScreen;
